#ifndef _BLOCK_H_
#define _BLOCK_H_

#define STATUS_FILE "/usr/share/nfs-device-disable/status"

enum DeviceType{
    USB = 0,
    BLUETOOTH,
    WIRELESSNET,
    WIREDNET,
};

enum OperatType{
    BLOCK = 0,
    ALLOW,
};

enum OutInterfaceType {
    OUT_INF_SERIAL = 0,  //串口
    OUT_INF_PARALLEL,  //并口
    OUT_INF_1394,  //1394 接口
    OUT_INF_PCMCIA,  //PCMCIA 接口

};

enum DeviceInterfaceType{
    UsbInterface = 0,
    WirednetInterface,
    WirelessnetInterface,
    Bluetooth,
    HDMI,

    DIT_DEV_BLUETOOTH, //蓝牙
    DIT_DEV_INFRARED,  //红外
    DIT_DEV_MODEM,  //modem 设备
    DIT_DEV_STORAGE_DRIVE, //存储驱动器(SD、TF 卡)
    DIT_DEV_SCSI_RAID,  //SCSI 及 RAID 控制器
    DIT_DEV_WINCE,  //wince 设备(安卓手机、pad 等)
    DIT_DEV_FLOPPY_DRIVE,  //软驱
    DIT_DEV_IMAGE,  //图像设备(包括摄像头、数码相机、扫描仪)
    DIT_DEV_MULTI_SERIAL_CARD, //多串口卡
    DIT_DEV_NET_CARD,  //网卡
    DIT_DEV_PRINTER,  //打印机
    DIT_DEV_CDROM,  //刻录

};

enum UsbDeviceType{
    UsbStorage = 0,
    Camera,
    Printer,

    UDT_USB_CLASS_PER_INTERFACE,  //00h,保留分类
    UDT_USB_CLASS_AUDIO,  //01h,音频设备
    UDT_USB_CLASS_COMM,  //02h,通信及通信类控制设备
    UDT_USB_CLASS_HID,  //03h,人体工学设备
    UDT_USB_CLASS_PHYSICAL,  //05h,物理设备
    UDT_USB_CLASS_STILL_IMAGE,  //06h,图像
    UDT_USB_CLASS_PRINTER,  //07h,打印设备
    UDT_USB_CLASS_MASS_STORAGE,  //08h,大容量存储
    UDT_USB_CLASS_HUB,  //09h,集线器
    UDT_USB_CLASS_CDC_DATA,  //0Ah,通信类数据设备
    UDT_USB_CLASS_CSCID,  //0Bh,智能卡
    UDT_USB_CLASS_CONTENT_SEC,  //0Dh,内容安全
    UDT_USB_CLASS_VIDEO,  //0Eh,视频
    UDT_USB_CLASS_WIRELESS_CONTROLLER, //E0h,无线控制器
    UDT_USB_CLASS_MISC,  //EFh,其他设备
    UDT_USB_CLASS_APP_SPEC,  //FEh,应用程序
    UDT_USB_CLASS_VENDOR_SPEC  //FFh,厂家自定义
};

enum PermissionsDeviceType{
    BuiltInCdrom = 0,
    Cdrom,
    RemovableStorage,
};

struct devctl_special_device_policy_forout {
    int usb_class;  //指定 usb 设备的子 class 类别
    unsigned int pid;  //指定设备的 pid
    unsigned int vid;  //指定设备的 vid
    int perm;  //指定设备的权限
    struct devctl_special_device_policy_forout* next;
};

int init_status_conf();
int set_device_control_status(int devicetype, int status);

int set_peripherals_control_switch(int status); // 外设管控功能开关接口
int set_out_interface_switch(int type, int status); // 接口控制接口-对外
int set_interface_switch(int type, int status); // 接口控制接口
int set_device_switch(int type, int status); // 设备控制接口
int set_permission_switch(int type, int status);

int get_unauthorized_deviceinfo();
int get_rules();
int modify_rules(char* status, char* vid, char* pid, char* serial, char* name, char* withinterface, char* anothername);
int set_rules(char* flag, char* status, char* vid, char* pid, char* serial, char* name, char* withinterface, char* devicetype);
int ImportFromXml(char *docname);
int ExportToXml(char *docname);

struct devctl_special_device_policy_forout *devctl_get_special_device_policies_forout(int *count);
int set_rules_with_vid_pid_type(char* flag, char* perm, char* vid, char* pid, char* type);

#endif